#ifndef EFL_UI_WIN_IMPL_HH
#define EFL_UI_WIN_IMPL_HH

#include "efl_ui_win.eo.hh"

namespace efl { namespace ui { 
inline ::efl::eolian::return_traits<Efl_Ui_Win_Indicator_Mode>::type Win::indicator_mode_get() const
{
   Efl_Ui_Win_Indicator_Mode __return_value =  ::efl_ui_win_indicator_mode_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Ui_Win_Indicator_Mode>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::indicator_mode_set( ::efl::eolian::in_traits<Efl_Ui_Win_Indicator_Mode>::type type) const
{
    ::efl_ui_win_indicator_mode_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Indicator_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Indicator_Mode>::type>(type));
}
inline ::efl::eolian::return_traits<Efl_Ui_Win_Keyboard_Mode>::type Win::keyboard_mode_get() const
{
   Efl_Ui_Win_Keyboard_Mode __return_value =  ::efl_ui_win_keyboard_mode_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Ui_Win_Keyboard_Mode>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::keyboard_mode_set( ::efl::eolian::in_traits<Efl_Ui_Win_Keyboard_Mode>::type mode) const
{
    ::efl_ui_win_keyboard_mode_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Keyboard_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Keyboard_Mode>::type>(mode));
}
inline ::efl::eolian::return_traits<bool>::type Win::wm_available_rotations_get( ::efl::eolian::out_traits<bool>::type allow_0,  ::efl::eolian::out_traits<bool>::type allow_90,  ::efl::eolian::out_traits<bool>::type allow_180,  ::efl::eolian::out_traits<bool>::type allow_270) const
{
   Eina_Bool __out_param_allow_0 = {};
   Eina_Bool __out_param_allow_90 = {};
   Eina_Bool __out_param_allow_180 = {};
   Eina_Bool __out_param_allow_270 = {};
   Eina_Bool __return_value =  ::efl_ui_win_wm_available_rotations_get(_eo_ptr()
      , & __out_param_allow_0
      , & __out_param_allow_90
      , & __out_param_allow_180
      , & __out_param_allow_270);
   ::efl::eolian::assign_out< ::efl::eolian::out_traits<bool>::type, Eina_Bool>(allow_0, __out_param_allow_0);
   ::efl::eolian::assign_out< ::efl::eolian::out_traits<bool>::type, Eina_Bool>(allow_90, __out_param_allow_90);
   ::efl::eolian::assign_out< ::efl::eolian::out_traits<bool>::type, Eina_Bool>(allow_180, __out_param_allow_180);
   ::efl::eolian::assign_out< ::efl::eolian::out_traits<bool>::type, Eina_Bool>(allow_270, __out_param_allow_270);
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::wm_available_rotations_set( ::efl::eolian::in_traits<bool>::type allow_0,  ::efl::eolian::in_traits<bool>::type allow_90,  ::efl::eolian::in_traits<bool>::type allow_180,  ::efl::eolian::in_traits<bool>::type allow_270) const
{
    ::efl_ui_win_wm_available_rotations_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(allow_0)
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(allow_90)
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(allow_180)
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(allow_270));
}
inline ::efl::eolian::return_traits<  ::efl::eina::range_array< ::efl::eina::string_view>>::type Win::wm_available_profiles_get() const
{
   const Eina_Array * __return_value =  ::efl_ui_win_wm_available_profiles_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<  ::efl::eina::range_array< ::efl::eina::string_view>>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::wm_available_profiles_set( ::efl::eolian::in_traits<  ::efl::eina::range_array< ::efl::eina::string_view>>::type profiles) const
{
    ::efl_ui_win_wm_available_profiles_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const Eina_Array *,  ::efl::eolian::in_traits<  ::efl::eina::range_array< ::efl::eina::string_view>>::type>(profiles));
}
inline ::efl::eolian::return_traits<bool>::type Win::screen_constrain_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_screen_constrain_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::screen_constrain_set( ::efl::eolian::in_traits<bool>::type constrain) const
{
    ::efl_ui_win_screen_constrain_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(constrain));
}
inline ::efl::eolian::return_traits<void>::type Win::prop_focus_skip_set( ::efl::eolian::in_traits<bool>::type skip) const
{
    ::efl_ui_win_prop_focus_skip_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(skip));
}
inline ::efl::eolian::return_traits<bool>::type Win::autohide_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_autohide_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::autohide_set( ::efl::eolian::in_traits<bool>::type autohide) const
{
    ::efl_ui_win_autohide_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(autohide));
}
inline ::efl::eolian::return_traits< ::efl::canvas::Object>::type Win::icon_object_get() const
{
    ::Efl_Canvas_Object const* __return_value =  ::efl_ui_win_icon_object_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::canvas::Object>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::icon_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type icon) const
{
    ::efl_ui_win_icon_object_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c< ::Efl_Canvas_Object*,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type>(icon));
}
inline ::efl::eolian::return_traits<bool>::type Win::iconified_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_iconified_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::iconified_set( ::efl::eolian::in_traits<bool>::type iconified) const
{
    ::efl_ui_win_iconified_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(iconified));
}
inline ::efl::eolian::return_traits<bool>::type Win::maximized_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_maximized_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::maximized_set( ::efl::eolian::in_traits<bool>::type maximized) const
{
    ::efl_ui_win_maximized_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(maximized));
}
inline ::efl::eolian::return_traits<bool>::type Win::fullscreen_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_fullscreen_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::fullscreen_set( ::efl::eolian::in_traits<bool>::type fullscreen) const
{
    ::efl_ui_win_fullscreen_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(fullscreen));
}
inline ::efl::eolian::return_traits<bool>::type Win::sticky_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_sticky_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::sticky_set( ::efl::eolian::in_traits<bool>::type sticky) const
{
    ::efl_ui_win_sticky_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(sticky));
}
inline ::efl::eolian::return_traits<Efl_Ui_Win_Urgent_Mode>::type Win::urgent_get() const
{
   Efl_Ui_Win_Urgent_Mode __return_value =  ::efl_ui_win_urgent_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Ui_Win_Urgent_Mode>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::urgent_set( ::efl::eolian::in_traits<Efl_Ui_Win_Urgent_Mode>::type urgent) const
{
    ::efl_ui_win_urgent_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Urgent_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Urgent_Mode>::type>(urgent));
}
inline ::efl::eolian::return_traits<Efl_Ui_Win_Modal_Mode>::type Win::modal_get() const
{
   Efl_Ui_Win_Modal_Mode __return_value =  ::efl_ui_win_modal_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Ui_Win_Modal_Mode>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::modal_set( ::efl::eolian::in_traits<Efl_Ui_Win_Modal_Mode>::type modal) const
{
    ::efl_ui_win_modal_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Modal_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Modal_Mode>::type>(modal));
}
inline ::efl::eolian::return_traits<bool>::type Win::noblank_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_noblank_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::noblank_set( ::efl::eolian::in_traits<bool>::type noblank) const
{
    ::efl_ui_win_noblank_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(noblank));
}
inline ::efl::eolian::return_traits<bool>::type Win::borderless_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_borderless_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::borderless_set( ::efl::eolian::in_traits<bool>::type borderless) const
{
    ::efl_ui_win_borderless_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(borderless));
}
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Win::win_role_get() const
{
   const char * __return_value =  ::efl_ui_win_role_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::win_role_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type role) const
{
    ::efl_ui_win_role_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(role));
}
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Win::win_name_get() const
{
   const char * __return_value =  ::efl_ui_win_name_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::win_name_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const
{
    ::efl_ui_win_name_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(name));
}
inline ::efl::eolian::return_traits<Efl_Ui_Win_Type>::type Win::win_type_get() const
{
   Efl_Ui_Win_Type __return_value =  ::efl_ui_win_type_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Ui_Win_Type>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::win_type_set( ::efl::eolian::in_traits<Efl_Ui_Win_Type>::type type) const
{
    ::efl_ui_win_type_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Type,  ::efl::eolian::in_traits<Efl_Ui_Win_Type>::type>(type));
}
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Win::accel_preference_get() const
{
   const char * __return_value =  ::efl_ui_win_accel_preference_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::accel_preference_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type accel) const
{
    ::efl_ui_win_accel_preference_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(accel));
}
inline ::efl::eolian::return_traits<bool>::type Win::alpha_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_alpha_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::alpha_set( ::efl::eolian::in_traits<bool>::type alpha) const
{
    ::efl_ui_win_alpha_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(alpha));
}
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Win::stack_id_get() const
{
   const char * __return_value =  ::efl_ui_win_stack_id_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
#endif
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Win::stack_master_id_get() const
{
   const char * __return_value =  ::efl_ui_win_stack_master_id_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
#endif
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits<void>::type Win::stack_master_id_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type id) const
{
    ::efl_ui_win_stack_master_id_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(id));
}
#endif
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits<bool>::type Win::stack_base_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_stack_base_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
#endif
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits<void>::type Win::stack_base_set( ::efl::eolian::in_traits<bool>::type base) const
{
    ::efl_ui_win_stack_base_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(base));
}
#endif
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits<void>::type Win::stack_pop_to() const
{
    ::efl_ui_win_stack_pop_to(_eo_ptr());
}
#endif
inline ::efl::eolian::return_traits<void>::type Win::activate() const
{
    ::efl_ui_win_activate(_eo_ptr());
}
inline ::efl::eolian::return_traits<void>::type Win::center( ::efl::eolian::in_traits<bool>::type h,  ::efl::eolian::in_traits<bool>::type v) const
{
    ::efl_ui_win_center(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(h)
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(v));
}
inline ::efl::eolian::return_traits<bool>::type Win::keygrab_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type modifiers,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type not_modifiers,  ::efl::eolian::in_traits<int>::type priority,  ::efl::eolian::in_traits<Efl_Ui_Win_Keygrab_Mode>::type grab_mode) const
{
   Eina_Bool __return_value =  ::efl_ui_win_keygrab_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(key)
      ,  ::efl::eolian::convert_to_c<Efl_Input_Modifier,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type>(modifiers)
      ,  ::efl::eolian::convert_to_c<Efl_Input_Modifier,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type>(not_modifiers)
      ,  ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(priority)
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Keygrab_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Keygrab_Mode>::type>(grab_mode));
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<bool>::type Win::keygrab_unset( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type modifiers,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type not_modifiers) const
{
   Eina_Bool __return_value =  ::efl_ui_win_keygrab_unset(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(key)
      ,  ::efl::eolian::convert_to_c<Efl_Input_Modifier,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type>(modifiers)
      ,  ::efl::eolian::convert_to_c<Efl_Input_Modifier,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type>(not_modifiers));
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<bool>::type Win::move_resize_start( ::efl::eolian::in_traits<Efl_Ui_Win_Move_Resize_Mode>::type mode) const
{
   Eina_Bool __return_value =  ::efl_ui_win_move_resize_start(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Move_Resize_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Move_Resize_Mode>::type>(mode));
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
} } 
namespace eo_cxx {
namespace efl { namespace ui { 
inline ::efl::eolian::return_traits<Efl_Ui_Win_Indicator_Mode>::type Win::indicator_mode_get() const
{
   Efl_Ui_Win_Indicator_Mode __return_value =  ::efl_ui_win_indicator_mode_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Ui_Win_Indicator_Mode>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::indicator_mode_set( ::efl::eolian::in_traits<Efl_Ui_Win_Indicator_Mode>::type type) const
{
    ::efl_ui_win_indicator_mode_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Indicator_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Indicator_Mode>::type>(type));
}
inline ::efl::eolian::return_traits<Efl_Ui_Win_Keyboard_Mode>::type Win::keyboard_mode_get() const
{
   Efl_Ui_Win_Keyboard_Mode __return_value =  ::efl_ui_win_keyboard_mode_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Ui_Win_Keyboard_Mode>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::keyboard_mode_set( ::efl::eolian::in_traits<Efl_Ui_Win_Keyboard_Mode>::type mode) const
{
    ::efl_ui_win_keyboard_mode_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Keyboard_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Keyboard_Mode>::type>(mode));
}
inline ::efl::eolian::return_traits<bool>::type Win::wm_available_rotations_get( ::efl::eolian::out_traits<bool>::type allow_0,  ::efl::eolian::out_traits<bool>::type allow_90,  ::efl::eolian::out_traits<bool>::type allow_180,  ::efl::eolian::out_traits<bool>::type allow_270) const
{
   Eina_Bool __out_param_allow_0 = {};
   Eina_Bool __out_param_allow_90 = {};
   Eina_Bool __out_param_allow_180 = {};
   Eina_Bool __out_param_allow_270 = {};
   Eina_Bool __return_value =  ::efl_ui_win_wm_available_rotations_get(_eo_ptr()
      , & __out_param_allow_0
      , & __out_param_allow_90
      , & __out_param_allow_180
      , & __out_param_allow_270);
   ::efl::eolian::assign_out< ::efl::eolian::out_traits<bool>::type, Eina_Bool>(allow_0, __out_param_allow_0);
   ::efl::eolian::assign_out< ::efl::eolian::out_traits<bool>::type, Eina_Bool>(allow_90, __out_param_allow_90);
   ::efl::eolian::assign_out< ::efl::eolian::out_traits<bool>::type, Eina_Bool>(allow_180, __out_param_allow_180);
   ::efl::eolian::assign_out< ::efl::eolian::out_traits<bool>::type, Eina_Bool>(allow_270, __out_param_allow_270);
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::wm_available_rotations_set( ::efl::eolian::in_traits<bool>::type allow_0,  ::efl::eolian::in_traits<bool>::type allow_90,  ::efl::eolian::in_traits<bool>::type allow_180,  ::efl::eolian::in_traits<bool>::type allow_270) const
{
    ::efl_ui_win_wm_available_rotations_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(allow_0)
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(allow_90)
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(allow_180)
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(allow_270));
}
inline ::efl::eolian::return_traits<  ::efl::eina::range_array< ::efl::eina::string_view>>::type Win::wm_available_profiles_get() const
{
   const Eina_Array * __return_value =  ::efl_ui_win_wm_available_profiles_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<  ::efl::eina::range_array< ::efl::eina::string_view>>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::wm_available_profiles_set( ::efl::eolian::in_traits<  ::efl::eina::range_array< ::efl::eina::string_view>>::type profiles) const
{
    ::efl_ui_win_wm_available_profiles_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const Eina_Array *,  ::efl::eolian::in_traits<  ::efl::eina::range_array< ::efl::eina::string_view>>::type>(profiles));
}
inline ::efl::eolian::return_traits<bool>::type Win::screen_constrain_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_screen_constrain_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::screen_constrain_set( ::efl::eolian::in_traits<bool>::type constrain) const
{
    ::efl_ui_win_screen_constrain_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(constrain));
}
inline ::efl::eolian::return_traits<void>::type Win::prop_focus_skip_set( ::efl::eolian::in_traits<bool>::type skip) const
{
    ::efl_ui_win_prop_focus_skip_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(skip));
}
inline ::efl::eolian::return_traits<bool>::type Win::autohide_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_autohide_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::autohide_set( ::efl::eolian::in_traits<bool>::type autohide) const
{
    ::efl_ui_win_autohide_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(autohide));
}
inline ::efl::eolian::return_traits< ::efl::canvas::Object>::type Win::icon_object_get() const
{
    ::Efl_Canvas_Object const* __return_value =  ::efl_ui_win_icon_object_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::canvas::Object>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::icon_object_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type icon) const
{
    ::efl_ui_win_icon_object_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c< ::Efl_Canvas_Object*,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type>(icon));
}
inline ::efl::eolian::return_traits<bool>::type Win::iconified_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_iconified_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::iconified_set( ::efl::eolian::in_traits<bool>::type iconified) const
{
    ::efl_ui_win_iconified_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(iconified));
}
inline ::efl::eolian::return_traits<bool>::type Win::maximized_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_maximized_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::maximized_set( ::efl::eolian::in_traits<bool>::type maximized) const
{
    ::efl_ui_win_maximized_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(maximized));
}
inline ::efl::eolian::return_traits<bool>::type Win::fullscreen_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_fullscreen_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::fullscreen_set( ::efl::eolian::in_traits<bool>::type fullscreen) const
{
    ::efl_ui_win_fullscreen_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(fullscreen));
}
inline ::efl::eolian::return_traits<bool>::type Win::sticky_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_sticky_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::sticky_set( ::efl::eolian::in_traits<bool>::type sticky) const
{
    ::efl_ui_win_sticky_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(sticky));
}
inline ::efl::eolian::return_traits<Efl_Ui_Win_Urgent_Mode>::type Win::urgent_get() const
{
   Efl_Ui_Win_Urgent_Mode __return_value =  ::efl_ui_win_urgent_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Ui_Win_Urgent_Mode>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::urgent_set( ::efl::eolian::in_traits<Efl_Ui_Win_Urgent_Mode>::type urgent) const
{
    ::efl_ui_win_urgent_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Urgent_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Urgent_Mode>::type>(urgent));
}
inline ::efl::eolian::return_traits<Efl_Ui_Win_Modal_Mode>::type Win::modal_get() const
{
   Efl_Ui_Win_Modal_Mode __return_value =  ::efl_ui_win_modal_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Ui_Win_Modal_Mode>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::modal_set( ::efl::eolian::in_traits<Efl_Ui_Win_Modal_Mode>::type modal) const
{
    ::efl_ui_win_modal_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Modal_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Modal_Mode>::type>(modal));
}
inline ::efl::eolian::return_traits<bool>::type Win::noblank_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_noblank_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::noblank_set( ::efl::eolian::in_traits<bool>::type noblank) const
{
    ::efl_ui_win_noblank_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(noblank));
}
inline ::efl::eolian::return_traits<bool>::type Win::borderless_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_borderless_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::borderless_set( ::efl::eolian::in_traits<bool>::type borderless) const
{
    ::efl_ui_win_borderless_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(borderless));
}
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Win::win_role_get() const
{
   const char * __return_value =  ::efl_ui_win_role_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::win_role_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type role) const
{
    ::efl_ui_win_role_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(role));
}
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Win::win_name_get() const
{
   const char * __return_value =  ::efl_ui_win_name_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::win_name_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const
{
    ::efl_ui_win_name_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(name));
}
inline ::efl::eolian::return_traits<Efl_Ui_Win_Type>::type Win::win_type_get() const
{
   Efl_Ui_Win_Type __return_value =  ::efl_ui_win_type_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Ui_Win_Type>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::win_type_set( ::efl::eolian::in_traits<Efl_Ui_Win_Type>::type type) const
{
    ::efl_ui_win_type_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Type,  ::efl::eolian::in_traits<Efl_Ui_Win_Type>::type>(type));
}
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Win::accel_preference_get() const
{
   const char * __return_value =  ::efl_ui_win_accel_preference_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::accel_preference_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type accel) const
{
    ::efl_ui_win_accel_preference_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(accel));
}
inline ::efl::eolian::return_traits<bool>::type Win::alpha_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_alpha_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<void>::type Win::alpha_set( ::efl::eolian::in_traits<bool>::type alpha) const
{
    ::efl_ui_win_alpha_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(alpha));
}
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Win::stack_id_get() const
{
   const char * __return_value =  ::efl_ui_win_stack_id_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
#endif
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits< ::efl::eina::string_view>::type Win::stack_master_id_get() const
{
   const char * __return_value =  ::efl_ui_win_stack_master_id_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::string_view>::type>(__return_value);
}
#endif
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits<void>::type Win::stack_master_id_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type id) const
{
    ::efl_ui_win_stack_master_id_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(id));
}
#endif
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits<bool>::type Win::stack_base_get() const
{
   Eina_Bool __return_value =  ::efl_ui_win_stack_base_get(_eo_ptr());
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
#endif
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits<void>::type Win::stack_base_set( ::efl::eolian::in_traits<bool>::type base) const
{
    ::efl_ui_win_stack_base_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(base));
}
#endif
#ifdef EFL_UI_WIN_BETA
inline ::efl::eolian::return_traits<void>::type Win::stack_pop_to() const
{
    ::efl_ui_win_stack_pop_to(_eo_ptr());
}
#endif
inline ::efl::eolian::return_traits<void>::type Win::activate() const
{
    ::efl_ui_win_activate(_eo_ptr());
}
inline ::efl::eolian::return_traits<void>::type Win::center( ::efl::eolian::in_traits<bool>::type h,  ::efl::eolian::in_traits<bool>::type v) const
{
    ::efl_ui_win_center(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(h)
      ,  ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(v));
}
inline ::efl::eolian::return_traits<bool>::type Win::keygrab_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type modifiers,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type not_modifiers,  ::efl::eolian::in_traits<int>::type priority,  ::efl::eolian::in_traits<Efl_Ui_Win_Keygrab_Mode>::type grab_mode) const
{
   Eina_Bool __return_value =  ::efl_ui_win_keygrab_set(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(key)
      ,  ::efl::eolian::convert_to_c<Efl_Input_Modifier,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type>(modifiers)
      ,  ::efl::eolian::convert_to_c<Efl_Input_Modifier,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type>(not_modifiers)
      ,  ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(priority)
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Keygrab_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Keygrab_Mode>::type>(grab_mode));
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<bool>::type Win::keygrab_unset( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type modifiers,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type not_modifiers) const
{
   Eina_Bool __return_value =  ::efl_ui_win_keygrab_unset(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<const char *,  ::efl::eolian::in_traits< ::efl::eina::string_view>::type>(key)
      ,  ::efl::eolian::convert_to_c<Efl_Input_Modifier,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type>(modifiers)
      ,  ::efl::eolian::convert_to_c<Efl_Input_Modifier,  ::efl::eolian::in_traits<Efl_Input_Modifier>::type>(not_modifiers));
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline ::efl::eolian::return_traits<bool>::type Win::move_resize_start( ::efl::eolian::in_traits<Efl_Ui_Win_Move_Resize_Mode>::type mode) const
{
   Eina_Bool __return_value =  ::efl_ui_win_move_resize_start(_eo_ptr()
      ,  ::efl::eolian::convert_to_c<Efl_Ui_Win_Move_Resize_Mode,  ::efl::eolian::in_traits<Efl_Ui_Win_Move_Resize_Mode>::type>(mode));
   return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
inline efl::ui::Win::operator ::efl::ui::Win() const { return *static_cast< ::efl::ui::Win const*>(static_cast<void const*>(this)); }
inline efl::ui::Win::operator ::efl::ui::Win&() { return *static_cast< ::efl::ui::Win*>(static_cast<void*>(this)); }
inline efl::ui::Win::operator ::efl::ui::Win const&() const { return *static_cast< ::efl::ui::Win const*>(static_cast<void const*>(this)); }
} } }
#endif
